git-am.txt: --ignore-date flag is not passed to git-apply
[alt-git.git] / git-am.sh
blobab39b3c2fa3cb6c6e68f6193e0c4038edf8af512
1 #!/bin/sh
3 # Copyright (c) 2005, 2006 Junio C Hamano
5 SUBDIRECTORY_OK=Yes
6 OPTIONS_KEEPDASHDASH=
7 OPTIONS_SPEC="\
8 git am [options] [<mbox>|<Maildir>...]
9 git am [options] (--resolved | --skip | --abort)
11 i,interactive run interactively
12 b,binary* (historical option -- no-op)
13 3,3way allow fall back on 3way merging if needed
14 q,quiet be quiet
15 s,signoff add a Signed-off-by line to the commit message
16 u,utf8 recode into utf8 (default)
17 k,keep pass -k flag to git-mailinfo
18 whitespace= pass it through git-apply
19 ignore-space-change pass it through git-apply
20 ignore-whitespace pass it through git-apply
21 directory= pass it through git-apply
22 C= pass it through git-apply
23 p= pass it through git-apply
24 patch-format= format the patch(es) are in
25 reject pass it through git-apply
26 resolvemsg= override error message when patch failure occurs
27 r,resolved to be used after a patch failure
28 skip skip the current patch
29 abort restore the original branch and abort the patching operation.
30 committer-date-is-author-date lie about committer date
31 ignore-date use current timestamp for author date
32 rebasing* (internal use for git-rebase)"
34 . git-sh-setup
35 prefix=$(git rev-parse --show-prefix)
36 set_reflog_action am
37 require_work_tree
38 cd_to_toplevel
40 git var GIT_COMMITTER_IDENT >/dev/null ||
41 die "You need to set your committer info first"
43 if git rev-parse --verify -q HEAD >/dev/null
44 then
45 HAS_HEAD=yes
46 else
47 HAS_HEAD=
50 sq () {
51 git rev-parse --sq-quote "$@"
54 stop_here () {
55 echo "$1" >"$dotest/next"
56 exit 1
59 stop_here_user_resolve () {
60 if [ -n "$resolvemsg" ]; then
61 printf '%s\n' "$resolvemsg"
62 stop_here $1
64 cmdline="git am"
65 if test '' != "$interactive"
66 then
67 cmdline="$cmdline -i"
69 if test '' != "$threeway"
70 then
71 cmdline="$cmdline -3"
73 echo "When you have resolved this problem run \"$cmdline --resolved\"."
74 echo "If you would prefer to skip this patch, instead run \"$cmdline --skip\"."
75 echo "To restore the original branch and stop patching run \"$cmdline --abort\"."
77 stop_here $1
80 go_next () {
81 rm -f "$dotest/$msgnum" "$dotest/msg" "$dotest/msg-clean" \
82 "$dotest/patch" "$dotest/info"
83 echo "$next" >"$dotest/next"
84 this=$next
87 cannot_fallback () {
88 echo "$1"
89 echo "Cannot fall back to three-way merge."
90 exit 1
93 fall_back_3way () {
94 O_OBJECT=`cd "$GIT_OBJECT_DIRECTORY" && pwd`
96 rm -fr "$dotest"/patch-merge-*
97 mkdir "$dotest/patch-merge-tmp-dir"
99 # First see if the patch records the index info that we can use.
100 git apply --build-fake-ancestor "$dotest/patch-merge-tmp-index" \
101 "$dotest/patch" &&
102 GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
103 git write-tree >"$dotest/patch-merge-base+" ||
104 cannot_fallback "Repository lacks necessary blobs to fall back on 3-way merge."
106 say Using index info to reconstruct a base tree...
107 if GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
108 git apply --cached <"$dotest/patch"
109 then
110 mv "$dotest/patch-merge-base+" "$dotest/patch-merge-base"
111 mv "$dotest/patch-merge-tmp-index" "$dotest/patch-merge-index"
112 else
113 cannot_fallback "Did you hand edit your patch?
114 It does not apply to blobs recorded in its index."
117 test -f "$dotest/patch-merge-index" &&
118 his_tree=$(GIT_INDEX_FILE="$dotest/patch-merge-index" git write-tree) &&
119 orig_tree=$(cat "$dotest/patch-merge-base") &&
120 rm -fr "$dotest"/patch-merge-* || exit 1
122 say Falling back to patching base and 3-way merge...
124 # This is not so wrong. Depending on which base we picked,
125 # orig_tree may be wildly different from ours, but his_tree
126 # has the same set of wildly different changes in parts the
127 # patch did not touch, so recursive ends up canceling them,
128 # saying that we reverted all those changes.
130 eval GITHEAD_$his_tree='"$FIRSTLINE"'
131 export GITHEAD_$his_tree
132 if test -n "$GIT_QUIET"
133 then
134 export GIT_MERGE_VERBOSITY=0
136 git-merge-recursive $orig_tree -- HEAD $his_tree || {
137 git rerere
138 echo Failed to merge in the changes.
139 exit 1
141 unset GITHEAD_$his_tree
144 clean_abort () {
145 test $# = 0 || echo >&2 "$@"
146 rm -fr "$dotest"
147 exit 1
150 patch_format=
152 check_patch_format () {
153 # early return if patch_format was set from the command line
154 if test -n "$patch_format"
155 then
156 return 0
159 # we default to mbox format if input is from stdin and for
160 # directories
161 if test $# = 0 || test "x$1" = "x-" || test -d "$1"
162 then
163 patch_format=mbox
164 return 0
167 # otherwise, check the first few lines of the first patch to try
168 # to detect its format
170 read l1
171 read l2
172 read l3
173 case "$l1" in
174 "From "* | "From: "*)
175 patch_format=mbox
177 '# This series applies on GIT commit'*)
178 patch_format=stgit-series
180 "# HG changeset patch")
181 patch_format=hg
184 # if the second line is empty and the third is
185 # a From, Author or Date entry, this is very
186 # likely an StGIT patch
187 case "$l2,$l3" in
188 ,"From: "* | ,"Author: "* | ,"Date: "*)
189 patch_format=stgit
193 esac
195 esac
196 } < "$1" || clean_abort
199 split_patches () {
200 case "$patch_format" in
201 mbox)
202 git mailsplit -d"$prec" -o"$dotest" -b -- "$@" > "$dotest/last" ||
203 clean_abort
205 stgit-series)
206 if test $# -ne 1
207 then
208 clean_abort "Only one StGIT patch series can be applied at once"
210 series_dir=`dirname "$1"`
211 series_file="$1"
212 shift
214 set x
215 while read filename
217 set "$@" "$series_dir/$filename"
218 done
219 # remove the safety x
220 shift
221 # remove the arg coming from the first-line comment
222 shift
223 } < "$series_file" || clean_abort
224 # set the patch format appropriately
225 patch_format=stgit
226 # now handle the actual StGIT patches
227 split_patches "$@"
229 stgit)
230 this=0
231 for stgit in "$@"
233 this=`expr "$this" + 1`
234 msgnum=`printf "%0${prec}d" $this`
235 # Perl version of StGIT parse_patch. The first nonemptyline
236 # not starting with Author, From or Date is the
237 # subject, and the body starts with the next nonempty
238 # line not starting with Author, From or Date
239 perl -ne 'BEGIN { $subject = 0 }
240 if ($subject > 1) { print ; }
241 elsif (/^\s+$/) { next ; }
242 elsif (/^Author:/) { print s/Author/From/ ; }
243 elsif (/^(From|Date)/) { print ; }
244 elsif ($subject) {
245 $subject = 2 ;
246 print "\n" ;
247 print ;
248 } else {
249 print "Subject: ", $_ ;
250 $subject = 1;
252 ' < "$stgit" > "$dotest/$msgnum" || clean_abort
253 done
254 echo "$this" > "$dotest/last"
255 this=
256 msgnum=
259 clean_abort "Patch format $patch_format is not supported."
261 esac
264 prec=4
265 dotest="$GIT_DIR/rebase-apply"
266 sign= utf8=t keep= skip= interactive= resolved= rebasing= abort=
267 resolvemsg= resume=
268 git_apply_opt=
269 committer_date_is_author_date=
270 ignore_date=
272 while test $# != 0
274 case "$1" in
275 -i|--interactive)
276 interactive=t ;;
277 -b|--binary)
278 : ;;
279 -3|--3way)
280 threeway=t ;;
281 -s|--signoff)
282 sign=t ;;
283 -u|--utf8)
284 utf8=t ;; # this is now default
285 --no-utf8)
286 utf8= ;;
287 -k|--keep)
288 keep=t ;;
289 -r|--resolved)
290 resolved=t ;;
291 --skip)
292 skip=t ;;
293 --abort)
294 abort=t ;;
295 --rebasing)
296 rebasing=t threeway=t keep=t ;;
297 -d|--dotest)
298 die "-d option is no longer supported. Do not use."
300 --resolvemsg)
301 shift; resolvemsg=$1 ;;
302 --whitespace|--directory)
303 git_apply_opt="$git_apply_opt $(sq "$1=$2")"; shift ;;
304 -C|-p)
305 git_apply_opt="$git_apply_opt $(sq "$1$2")"; shift ;;
306 --patch-format)
307 shift ; patch_format="$1" ;;
308 --reject|--ignore-whitespace|--ignore-space-change)
309 git_apply_opt="$git_apply_opt $1" ;;
310 --committer-date-is-author-date)
311 committer_date_is_author_date=t ;;
312 --ignore-date)
313 ignore_date=t ;;
314 -q|--quiet)
315 GIT_QUIET=t ;;
317 shift; break ;;
319 usage ;;
320 esac
321 shift
322 done
324 # If the dotest directory exists, but we have finished applying all the
325 # patches in them, clear it out.
326 if test -d "$dotest" &&
327 last=$(cat "$dotest/last") &&
328 next=$(cat "$dotest/next") &&
329 test $# != 0 &&
330 test "$next" -gt "$last"
331 then
332 rm -fr "$dotest"
335 if test -d "$dotest"
336 then
337 case "$#,$skip$resolved$abort" in
338 0,*t*)
339 # Explicit resume command and we do not have file, so
340 # we are happy.
341 : ;;
343 # No file input but without resume parameters; catch
344 # user error to feed us a patch from standard input
345 # when there is already $dotest. This is somewhat
346 # unreliable -- stdin could be /dev/null for example
347 # and the caller did not intend to feed us a patch but
348 # wanted to continue unattended.
349 test -t 0
352 false
354 esac ||
355 die "previous rebase directory $dotest still exists but mbox given."
356 resume=yes
358 case "$skip,$abort" in
359 t,t)
360 die "Please make up your mind. --skip or --abort?"
363 git rerere clear
364 git read-tree --reset -u HEAD HEAD
365 orig_head=$(cat "$GIT_DIR/ORIG_HEAD")
366 git reset HEAD
367 git update-ref ORIG_HEAD $orig_head
370 if test -f "$dotest/rebasing"
371 then
372 exec git rebase --abort
374 git rerere clear
375 test -f "$dotest/dirtyindex" || {
376 git read-tree --reset -u HEAD ORIG_HEAD
377 git reset ORIG_HEAD
379 rm -fr "$dotest"
380 exit ;;
381 esac
382 rm -f "$dotest/dirtyindex"
383 else
384 # Make sure we are not given --skip, --resolved, nor --abort
385 test "$skip$resolved$abort" = "" ||
386 die "Resolve operation not in progress, we are not resuming."
388 # Start afresh.
389 mkdir -p "$dotest" || exit
391 if test -n "$prefix" && test $# != 0
392 then
393 first=t
394 for arg
396 test -n "$first" && {
397 set x
398 first=
400 case "$arg" in
402 set "$@" "$arg" ;;
404 set "$@" "$prefix$arg" ;;
405 esac
406 done
407 shift
410 check_patch_format "$@"
412 split_patches "$@"
414 # -s, -u, -k, --whitespace, -3, -C, -q and -p flags are kept
415 # for the resuming session after a patch failure.
416 # -i can and must be given when resuming.
417 echo " $git_apply_opt" >"$dotest/apply-opt"
418 echo "$threeway" >"$dotest/threeway"
419 echo "$sign" >"$dotest/sign"
420 echo "$utf8" >"$dotest/utf8"
421 echo "$keep" >"$dotest/keep"
422 echo "$GIT_QUIET" >"$dotest/quiet"
423 echo 1 >"$dotest/next"
424 if test -n "$rebasing"
425 then
426 : >"$dotest/rebasing"
427 else
428 : >"$dotest/applying"
429 if test -n "$HAS_HEAD"
430 then
431 git update-ref ORIG_HEAD HEAD
432 else
433 git update-ref -d ORIG_HEAD >/dev/null 2>&1
438 case "$resolved" in
440 case "$HAS_HEAD" in
442 files=$(git ls-files) ;;
444 files=$(git diff-index --cached --name-only HEAD --) ;;
445 esac || exit
446 if test "$files"
447 then
448 test -n "$HAS_HEAD" && : >"$dotest/dirtyindex"
449 die "Dirty index: cannot apply patches (dirty: $files)"
451 esac
453 if test "$(cat "$dotest/utf8")" = t
454 then
455 utf8=-u
456 else
457 utf8=-n
459 if test "$(cat "$dotest/keep")" = t
460 then
461 keep=-k
463 if test "$(cat "$dotest/quiet")" = t
464 then
465 GIT_QUIET=t
467 if test "$(cat "$dotest/threeway")" = t
468 then
469 threeway=t
471 git_apply_opt=$(cat "$dotest/apply-opt")
472 if test "$(cat "$dotest/sign")" = t
473 then
474 SIGNOFF=`git var GIT_COMMITTER_IDENT | sed -e '
475 s/>.*/>/
476 s/^/Signed-off-by: /'
478 else
479 SIGNOFF=
482 last=`cat "$dotest/last"`
483 this=`cat "$dotest/next"`
484 if test "$skip" = t
485 then
486 this=`expr "$this" + 1`
487 resume=
490 if test "$this" -gt "$last"
491 then
492 say Nothing to do.
493 rm -fr "$dotest"
494 exit
497 while test "$this" -le "$last"
499 msgnum=`printf "%0${prec}d" $this`
500 next=`expr "$this" + 1`
501 test -f "$dotest/$msgnum" || {
502 resume=
503 go_next
504 continue
507 # If we are not resuming, parse and extract the patch information
508 # into separate files:
509 # - info records the authorship and title
510 # - msg is the rest of commit log message
511 # - patch is the patch body.
513 # When we are resuming, these files are either already prepared
514 # by the user, or the user can tell us to do so by --resolved flag.
515 case "$resume" in
517 git mailinfo $keep $utf8 "$dotest/msg" "$dotest/patch" \
518 <"$dotest/$msgnum" >"$dotest/info" ||
519 stop_here $this
521 # skip pine's internal folder data
522 grep '^Author: Mail System Internal Data$' \
523 <"$dotest"/info >/dev/null &&
524 go_next && continue
526 test -s "$dotest/patch" || {
527 echo "Patch is empty. Was it split wrong?"
528 stop_here $this
530 if test -f "$dotest/rebasing" &&
531 commit=$(sed -e 's/^From \([0-9a-f]*\) .*/\1/' \
532 -e q "$dotest/$msgnum") &&
533 test "$(git cat-file -t "$commit")" = commit
534 then
535 git cat-file commit "$commit" |
536 sed -e '1,/^$/d' >"$dotest/msg-clean"
537 else
538 SUBJECT="$(sed -n '/^Subject/ s/Subject: //p' "$dotest/info")"
539 case "$keep_subject" in -k) SUBJECT="[PATCH] $SUBJECT" ;; esac
541 (printf '%s\n\n' "$SUBJECT"; cat "$dotest/msg") |
542 git stripspace > "$dotest/msg-clean"
545 esac
547 GIT_AUTHOR_NAME="$(sed -n '/^Author/ s/Author: //p' "$dotest/info")"
548 GIT_AUTHOR_EMAIL="$(sed -n '/^Email/ s/Email: //p' "$dotest/info")"
549 GIT_AUTHOR_DATE="$(sed -n '/^Date/ s/Date: //p' "$dotest/info")"
551 if test -z "$GIT_AUTHOR_EMAIL"
552 then
553 echo "Patch does not have a valid e-mail address."
554 stop_here $this
557 export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
559 case "$resume" in
561 if test '' != "$SIGNOFF"
562 then
563 LAST_SIGNED_OFF_BY=`
564 sed -ne '/^Signed-off-by: /p' \
565 "$dotest/msg-clean" |
566 sed -ne '$p'
568 ADD_SIGNOFF=`
569 test "$LAST_SIGNED_OFF_BY" = "$SIGNOFF" || {
570 test '' = "$LAST_SIGNED_OFF_BY" && echo
571 echo "$SIGNOFF"
573 else
574 ADD_SIGNOFF=
577 if test -s "$dotest/msg-clean"
578 then
579 cat "$dotest/msg-clean"
581 if test '' != "$ADD_SIGNOFF"
582 then
583 echo "$ADD_SIGNOFF"
585 } >"$dotest/final-commit"
588 case "$resolved$interactive" in
590 # This is used only for interactive view option.
591 git diff-index -p --cached HEAD -- >"$dotest/patch"
593 esac
594 esac
596 resume=
597 if test "$interactive" = t
598 then
599 test -t 0 ||
600 die "cannot be interactive without stdin connected to a terminal."
601 action=again
602 while test "$action" = again
604 echo "Commit Body is:"
605 echo "--------------------------"
606 cat "$dotest/final-commit"
607 echo "--------------------------"
608 printf "Apply? [y]es/[n]o/[e]dit/[v]iew patch/[a]ccept all "
609 read reply
610 case "$reply" in
611 [yY]*) action=yes ;;
612 [aA]*) action=yes interactive= ;;
613 [nN]*) action=skip ;;
614 [eE]*) git_editor "$dotest/final-commit"
615 action=again ;;
616 [vV]*) action=again
617 LESS=-S ${PAGER:-less} "$dotest/patch" ;;
618 *) action=again ;;
619 esac
620 done
621 else
622 action=yes
624 FIRSTLINE=$(sed 1q "$dotest/final-commit")
626 if test $action = skip
627 then
628 go_next
629 continue
632 if test -x "$GIT_DIR"/hooks/applypatch-msg
633 then
634 "$GIT_DIR"/hooks/applypatch-msg "$dotest/final-commit" ||
635 stop_here $this
638 say "Applying: $FIRSTLINE"
640 case "$resolved" in
642 # When we are allowed to fall back to 3-way later, don't give
643 # false errors during the initial attempt.
644 squelch=
645 if test "$threeway" = t
646 then
647 squelch='>/dev/null 2>&1 '
649 eval "git apply $squelch$git_apply_opt"' --index "$dotest/patch"'
650 apply_status=$?
653 # Resolved means the user did all the hard work, and
654 # we do not have to do any patch application. Just
655 # trust what the user has in the index file and the
656 # working tree.
657 resolved=
658 git diff-index --quiet --cached HEAD -- && {
659 echo "No changes - did you forget to use 'git add'?"
660 stop_here_user_resolve $this
662 unmerged=$(git ls-files -u)
663 if test -n "$unmerged"
664 then
665 echo "You still have unmerged paths in your index"
666 echo "did you forget to use 'git add'?"
667 stop_here_user_resolve $this
669 apply_status=0
670 git rerere
672 esac
674 if test $apply_status = 1 && test "$threeway" = t
675 then
676 if (fall_back_3way)
677 then
678 # Applying the patch to an earlier tree and merging the
679 # result may have produced the same tree as ours.
680 git diff-index --quiet --cached HEAD -- && {
681 say No changes -- Patch already applied.
682 go_next
683 continue
685 # clear apply_status -- we have successfully merged.
686 apply_status=0
689 if test $apply_status != 0
690 then
691 printf 'Patch failed at %s %s\n' "$msgnum" "$FIRSTLINE"
692 stop_here_user_resolve $this
695 if test -x "$GIT_DIR"/hooks/pre-applypatch
696 then
697 "$GIT_DIR"/hooks/pre-applypatch || stop_here $this
700 tree=$(git write-tree) &&
701 commit=$(
702 if test -n "$ignore_date"
703 then
704 GIT_AUTHOR_DATE=
706 parent=$(git rev-parse --verify -q HEAD) ||
707 say >&2 "applying to an empty history"
709 if test -n "$committer_date_is_author_date"
710 then
711 GIT_COMMITTER_DATE="$GIT_AUTHOR_DATE"
712 export GIT_COMMITTER_DATE
713 fi &&
714 git commit-tree $tree ${parent:+-p} $parent <"$dotest/final-commit"
715 ) &&
716 git update-ref -m "$GIT_REFLOG_ACTION: $FIRSTLINE" HEAD $commit $parent ||
717 stop_here $this
719 if test -x "$GIT_DIR"/hooks/post-applypatch
720 then
721 "$GIT_DIR"/hooks/post-applypatch
724 go_next
725 done
727 git gc --auto
729 rm -fr "$dotest"